/* Mastertest
 * Berechnet die Leistungsfaehigkeit von 'Masterbrain'.
 *
 * Stefan Arnold XI.03
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Anzahl der Zahlen im Geheimcode */
#define CODELAENGE 4

#include "Mastermind.h"


/* Startet den Mastertest. */
int main()
{
    zahl Optionen;
    int charZahl,i;
    index j,k;
    wertigkeit W;
    menge M;
    code Code,Tip;
    bewertung b;
    unsigned int Zaehler=0,Status,Statusbalken=0;
    time_t start;

    /* Wir gehen davon aus, dass 'sizeof(char)==1'
       und ein 'char' somit 8 Bits entspricht. */
    if (sizeof(char)!=1)
    {
        fprintf(stderr,"Interner Fehler.\n");
        return 2;
    }

    /* Einlesen der Anzahl von in Codes erlaubten Zahlen */
    printf("Wieviele Zahlen sollen zur Auswahl stehen?\n");
    scanf("%u",&Optionen);
    if (Optionen==0)
    {
        printf("Dann halt nicht...\n");
        return 0;
    }
    Optionen=(zahl)(Optionen>MAX_OPTIONEN? MAX_OPTIONEN: Optionen);
    Optionen=(zahl)(Optionen<CODELAENGE? CODELAENGE: Optionen);

    /* Stoppuhr starten */
    start=time(NULL);

    /* Berechnung der Anzahl moeglicher Codes */
    M.size=1;
    for(i=0;i<CODELAENGE;i++)
        M.size*=(Optionen-i);

    /* noetiger Speicherplatz in Bytes */
    charZahl=(M.size+7)/8;

    printf("Optionen: %u, moegliche Codes: %u.\n",Optionen,M.size);

    berechneWertigkeiten(W,Optionen);
    M.elem=calloc(charZahl,1);

    printf(" ____________________\n ");
    for(j=0;j<M.size;j++)
    {
        Status=(unsigned int)((double)j/(double)(M.size-1)*20);
        for(k=0;k<Status-Statusbalken;k++)
            putchar((unsigned char)219);
        Statusbalken=Status;

        /* Zunaechst sind alle Codes moeglich. */
        for(i=0;i<charZahl;i++)
            M.elem[i]=255;

        /* Code und ersten Tip (o.B.d.A. 0) festlegen */
        extrahiereCode(j,Code,W,Optionen);
        extrahiereCode(0,Tip,W,Optionen);

        while(1)
        {
            Zaehler++;
            b=getBewertung(Code,Tip,Optionen);
            if(b.schwarz==CODELAENGE)
                break;
            berechneVerbleibende(M,Tip,b,Optionen);
            if (berechneTip(Tip,M,Optionen)<0)
            {
                free(M.elem);
                printf("Keine verbleibenden Moeglichkeiten.\n");
                printf("Interner Fehler.\n");
                return 1;
            }
            b=getBewertung(Code,Tip,Optionen);
        }
    }
    printf("\n\n");
    printf("Gesamttips:                    %6u\n",Zaehler);
    printf("Durchschnittliche Anzahl Tips: %11.4f\n",((float)Zaehler)/M.size);
    printf("Rechendauer:                   %6.0fs\n",difftime(time(0),start));
    free(M.elem);
    return 0;
}
